<?php
/**
* @version      2.5.3 20.11.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');

include_once(dirname(__FILE__)."/parse_string.php");

function setMetaData($title, $keyword, $description) {
    $document =& JFactory::getDocument();
    $document->setTitle($title);
    $document->setMetadata('keywords',$keyword);  
    $document->setMetadata('description',$description);
}

function parseArrayToParams($array) {
    $str = '';
    foreach ($array as $key => $value) {
        $str .= $key . "=" . $value . "\n";
    }
    return $str;
}

function parseParamsToArray($string) {
    $temp = explode("\n",$string);
    foreach ($temp as $key => $value) {
        if(!$value) continue;
        $temp2 = explode("=",$value);
        $array[$temp2[0]] = $temp2[1];
    }
    return $array;
}

function outputDigit($digit, $count_null) {
    $length = strlen(strval($digit));
    for ($i = 0; $i < $count_null - $length; $i++) {
        $digit = '0' . $digit;
    }
    return $digit;
}

function splitValuesArrayObject($array_object,$property_name) {
    $return = '';
	if (is_array($array_object)){
		foreach ($array_object as $key => $value) {
	        $return .= $array_object[$key]->$property_name . ', ';
	    }
	    $return = "( " . substr($return,0,strlen($return) - 2) . " )";
    }
    return $return;
}

function getTextNameArrayValue($names, $values){    
    $return = '';
    foreach ($names as $key => $value) {
        $return .= $names[$key] . ": " . $values[$key] . "\n";
    }
    return $return;
}

function inserArraySmall(){
    $jshopxkey = 'PGEgc3R5bGU9ImRpc3BsYXk6bm9uZTsiIGhyZWYgPSAiaHR0cDovL3d3dy53ZWJkZXNpZ25lci1wcm9maS5kZS8iPldlYmRlc2lnbjwvYT4=';
    if (!checkLicense()){
        print base64_decode($jshopxkey);
    }
}

// when value not search add to array and sort 
function insertValueInArray($value, &$array) {
    if ($key = array_search($value, $array)) return $key;
    $array[$value] = $value;
    asort($array);
    return $key - 1;
}

function appendExtendPathWay($array, $page) {
    $app =& JFactory::getApplication();
    $pathway = &$app->getPathway();    
    foreach ($array as $cat) {    
        $pathway->addItem($cat->name, SEFLink('index.php?option=com_jshopping&controller=category&task=view&category_id=' . $cat->category_id));
    }
}

function appendPathWay($page){
    $app =& JFactory::getApplication();
    $pathway = &$app->getPathway();
    $pathway->addItem($page);
}

function formatprice($price, $currency_code = null) {
    $jshopConfig = &JSFactory::getConfig();

    if (!$currency_code) $currency_code = $jshopConfig->currency_code;
    $price = number_format($price, $jshopConfig->decimal_count, $jshopConfig->decimal_symbol, $jshopConfig->thousand_separator);
	$return = str_replace("Symb", $currency_code, str_replace("00", $price, $jshopConfig->format_currency[$jshopConfig->currency_format]));
    return $return;
}

function formatdate($date, $showtime = 0){
    $jshopConfig = &JSFactory::getConfig();    
    $format = $jshopConfig->store_date_format;
    if ($showtime) $format = $format." %H:%M:%S";
    return strftime($format, strtotime($date));
}

function formattax($val){
    $jshopConfig = &JSFactory::getConfig();
    $val = floatval($val);    
    return str_replace(".", $jshopConfig->decimal_symbol, $val);    
}

function formatweight($val){
    $jshopConfig = &JSFactory::getConfig();
    $val = floatval($val);    
    return str_replace(".", $jshopConfig->decimal_symbol, $val);    
}

/**
* get system language
* 
* @param int $client (0 - site, 1 - admin)
*/
function getAllLanguages( $client=0 ) {
    $pattern = '#(.*?)\(#is';
    $client	=& JApplicationHelper::getClientInfo($client);    
    $rows	= array ();
    jimport('joomla.filesystem.folder');
    $path = JLanguage::getLanguagePath($client->path);    
    $dirs = JFolder::folders( $path );
    foreach ($dirs as $dir){
        $files = JFolder::files( $path.DS.$dir, '^([-_A-Za-z]*)\.xml$' );
        foreach ($files as $file){
            $data = JApplicationHelper::parseXMLLangMetaFile($path.DS.$dir.DS.$file);
            $row = new StdClass();
            $row->descr = $data['name'];
            $row->language = substr($file,0,-4);
            $row->lang = substr($row->language,0,2);
            $row->name = $data['name'];
            preg_match($pattern, $row->name, $matches);
            if (isset($matches[1])) $row->name = trim($matches[1]);
            if (!is_array($data)) continue;            
            $rows[] = $row;
        }
    }
    return $rows;
}

function installNewLanguages($defaultLanguage = "", $show_message = 1){
    $db =& JFactory::getDBO();
    $jshopConfig = &JSFactory::getConfig();
    $session =& JFactory::getSession();
    $joomlaLangs = getAllLanguages();
    $checkedlanguage = $session->get('jshop_checked_language');
    if (is_array($checkedlanguage)){
        $newlanguages = 0;
        foreach($joomlaLangs as $lang){
            if (!in_array($lang->language, $checkedlanguage)) $newlanguages++;  
        }
        if ($newlanguages==0) return 0;
    }
    
    $query = "select * from #__jshopping_languages";
    $db->setQuery($query);
    $shopLangs = $db->loadObjectList();
    $shopLangsTag = array();
    foreach($shopLangs as $lang){
        $shopLangsTag[] = $lang->language;
    }

    if (!$defaultLanguage) $defaultLanguage = $jshopConfig->defaultLanguage;
    
    $checkedlanguage = array();
    $installed_new_lang = 0;
    
    foreach($joomlaLangs as $lang){
        $checkedlanguage[] = $lang->language;
        if (!in_array($lang->language, $shopLangsTag)){
            $ml = &JSFactory::getLang();
            if ($ml->addNewFieldLandInTables($lang->language, $defaultLanguage)){
                $installed_new_lang = 1;                
                $query = "insert into #__jshopping_languages set `language`='".$db->getEscaped($lang->language)."', `name`='".$db->getEscaped($lang->name)."', `publish`='1'";
                $db->setQuery($query);
                $db->query();
                if ($show_message){
                    JError::raiseNotice("", _JSHOP_INSTALLED_NEW_LANGUAGES.": ".$lang->name);
                }
            }
        }
    }       
    $session->set("jshop_checked_language", $checkedlanguage);
    return 1;
}

function recurseTree($cat, $level, $all_cats, &$categories, $is_select) {
    $probil = '';
    if($is_select) {
        for ($i = 0; $i < 2 * $level; $i++) {
            $probil .= '&nbsp;';
        }
        $cat->name = ($probil . $cat->name);        
        $categories[] = JHTML::_('select.option', $cat->category_id, $cat->name,'category_id','name' );
    } else {
        $cat->level = $level;
        $categories[] = $cat;
    }
    foreach ($all_cats as $categ) {
        if($categ->category_parent_id == $cat->category_id) {
            recurseTree($categ, ++$level, $all_cats, $categories, $is_select);
            $level--;
        }
    }
    return $categories;
}

function buildTreeCategory($publish = 1, $is_select = 1) {
	$jshopConfig = &JSFactory::getConfig();
    $db =& JFactory::getDBO();
    $lang = &JSFactory::getLang(); 
    $where_add = ($publish) ? (" where category_publish = '1' ") : ("");
    $query = "SELECT `".$lang->get('name')."` as name, category_id, category_parent_id, category_publish FROM `#__jshopping_categories`
           	  ".$where_add." ORDER BY category_parent_id, category_ordering";
    $db->setQuery($query);
    $all_cats = $db->loadObjectList();
    
    $categories = array();
	if(count($all_cats)) {
        foreach ($all_cats as $key => $value) {
            if(!$value->category_parent_id){
                recurseTree($value, 0, $all_cats, $categories, $is_select);
            }
        }
    }
    return $categories;
}

function _getCategoryParent($cat, $parent){
    $res = array();
    foreach($cat as $obj){
        if ($obj->category_parent_id == $parent) $res[] = $obj;
    } 
return $res;
}

function _getResortCategoryTree(&$cats, $allcats){
    foreach($cats as $k=>$v){
        $cats_sub = _getCategoryParent($allcats, $v->category_id);
        if (count($cats_sub)){
            _getResortCategoryTree($cats_sub, $allcats);            
        }
        $cats[$k]->subcat = $cats_sub;        
    }
}

/**
* get Tree category
* @param int $publish
* @return array
*/
function getTreeCategory($publish = 1){
    $jshopConfig = &JSFactory::getConfig();
    $db =& JFactory::getDBO();
    $lang = &JSFactory::getLang(); 
    $where_add = ($publish) ? (" where category_publish = '1' ") : ("");
    $query = "SELECT `".$lang->get('name')."` as name, category_id, category_parent_id FROM `#__jshopping_categories` ".$where_add." ORDER BY category_parent_id, category_ordering";
    $db->setQuery($query);
    $allcats = $db->loadObjectList();
        
    $cats = _getCategoryParent($allcats, 0);
    _getResortCategoryTree($cats, $allcats);
    
    return $cats;
}

/**
* check date Format date yyyy-mm-dd
*/
function checkMyDate($date) {
    if (trim($date)=="") return false;
    $arr = explode("-",$date);
    return checkdate($arr[1],$arr[2],$arr[0]);
}

function getThisURLMainPageShop(){
    $shopMainPageItemid = getShopMainPageItemid();
    $Itemid = JRequest::getInt("Itemid");
    return ($shopMainPageItemid==$Itemid && $Itemid!=0);
}

function getShopMainPageItemid(){
static $Itemid;
    if (!isset($Itemid)){
        $session =& JFactory::getSession();
        $Itemid = $session->get('shop_main_page_itemid');
        if (!isset($Itemid)){
            $db = &JFactory::getDBO();
            $query = "SELECT menu.id FROM `#__menu` AS menu WHERE menu.link = 'index.php?option=com_jshopping&controller=category' AND menu.published = '1'";
            $db->setQuery($query);
            $Itemid = $db->loadResult();
        }
        if (!$Itemid) $Itemid = 0;
        $session->set("shop_main_page_itemid", $Itemid);
    }
return $Itemid;
}

function getShopManufacturerPageItemid(){
static $Itemid;
    if (!isset($Itemid)){
        $session =& JFactory::getSession();
        $Itemid = $session->get('shop_manufacturer_page_itemid');
        if (!isset($Itemid)){
            $db = &JFactory::getDBO();
            $query = "SELECT menu.id FROM `#__menu` AS menu WHERE menu.link = 'index.php?option=com_jshopping&controller=manufacturer' AND menu.published = '1'";
            $db->setQuery($query);
            $Itemid = $db->loadResult();
        }
        if (!$Itemid) $Itemid = 0;
        $session->set("shop_manufacturer_page_itemid", $Itemid);
    }
return $Itemid;
}

function getDefaultItemid() {
static $Itemid;
	if (!$Itemid){
        $session =& JFactory::getSession();
	    $Itemid = getShopMainPageItemid();
	    if (!$Itemid) $Itemid = $session->get('shop_default_itemid');
    }
    return $Itemid;
}

function checkUserLogin() {
    $user = &JFactory::getUser();
    header("Cache-Control: no-cache, must-revalidate");
    if(!$user->id) {
        $mainframe =& JFactory::getApplication();
        $return = base64_encode($_SERVER['REQUEST_URI']);
        $session =& JFactory::getSession();
        $session->set("return", $return);
        $mainframe->redirect(SEFLink('index.php?option=com_jshopping&controller=user&task=login', 0, 1));
        exit();
    }
    return 1;
}

function checkLicense(){
    $jshopConfig = &JSFactory::getConfig();
    $host = str_replace("www.","",$_SERVER['HTTP_HOST']);
    if (base64_encode($host)==$jshopConfig->licensekod) return 1; else return 0;
}

function addLinkToProducts(&$products, $default_category_id = 0, $useDefaultItemId = 0) {
    $jshopConfig = &JSFactory::getConfig();
    foreach ($products as $key => $value) {
        $category_id = (!$default_category_id)?($products[$key]->category_id):($default_category_id);
        if (!$category_id) $category_id = 0;
        $products[$key]->product_link = SEFLink('index.php?option=com_jshopping&controller=product&task=view&category_id='.$category_id.'&product_id='.$products[$key]->product_id, $useDefaultItemId);
        if ($jshopConfig->show_buy_in_category){            
            if (!($jshopConfig->hide_buy_not_avaible_stock && ($products[$key]->product_quantity <= 0))){
                $products[$key]->buy_link = SEFLink('index.php?option=com_jshopping&controller=cart&task=add&category_id='.$category_id.'&product_id='.$products[$key]->product_id, $useDefaultItemId);        
            }
        }
    }
}

function searchChildCategories($category_id,$all_categories,&$cat_search) {
    foreach ($all_categories as $all_cat) {
        if($all_cat->category_parent_id == $category_id) {
            searchChildCategories($all_cat->category_id, $all_categories, $cat_search);
            $cat_search[] = $all_cat->category_id;
        }
    }
}

/**
* set Sef Link
* 
* @param string $link
* @param int $useDefaultItemId - (0 - current itemid, 1 - shop page itemid, 2 -manufacturer itemid)
* @param int $redirect
*/
function SEFLink($link, $useDefaultItemId = 0, $redirect = 0) {
    $defaultItemid = getDefaultItemid();
    if ($useDefaultItemId==2){
        $Itemid = getShopManufacturerPageItemid();
        if (!$Itemid) $Itemid = $defaultItemid;
        if (!$Itemid) $Itemid = JRequest::getInt('Itemid');
    }elseif ($useDefaultItemId==1){
        $Itemid = $defaultItemid;
        if (!$Itemid) $Itemid = JRequest::getInt('Itemid');
    }else{
        $Itemid = JRequest::getInt('Itemid');
        if (!$Itemid) $Itemid = $defaultItemid;        
    }    
    if ($link == "index.php") $link .= '?Itemid=' . $Itemid; else $link .= '&Itemid=' . $Itemid;
   	$link = JRoute::_($link, (($redirect) ? (false) : (true)));    
    return $link;
}

function replaceNbsp($string) {
    return (str_replace(" ","_",$string));
}

function replaceToNbsp($string) {
    return (str_replace("_"," ",$string));
}

function isWritable($directory) {
    $jshopConfig = &JSFactory::getConfig();
    return $return = is_writable($jshopConfig->path . "/" . $directory)?('({ "isWrite" : "1", "text" : "' . _JSHOP_WRITEABLE . '" })'):('({ "isWrite" : "0", "text" : "' . _JSHOP_NON_WRITEABLE . '"})');
}

function sprintRadioList($list, $name, $params, $key, $val, $actived = null){
    $html = "";
    $id = str_replace("[","",$name);
    $id = str_replace("]","",$id);
    foreach($list as $obj){
        if ($obj->$key == $actived) $sel = ' checked="true"'; else $sel = '';
        $html.='<input type="radio" name="'.$name.'" id="'.$id.'" value="'.$obj->$key.'"'.$sel.' '.$params.'> '.$obj->$val;
    }
    return $html;    
}

function saveToLog($file, $text){
    $jshopConfig = &JSFactory::getConfig();
    if (!$jshopConfig->savelog) return 0;
    $f = fopen($jshopConfig->log_path.$file, "a+");
    fwrite($f, date('Y-m-d H:i:s')." ".$text."\r\n");
    fclose($f);
    return 1;
}

function filterHTMLSafe(&$mixed, $quote_style=ENT_QUOTES, $exclude_keys='' ){
    if (is_object( $mixed ))
    {            
        foreach (get_object_vars( $mixed ) as $k => $v)
        {
            if (is_array( $v ) || is_object( $v ) || $v == NULL) {
                continue;
            }

            if (is_string( $exclude_keys ) && $k == $exclude_keys) {
                continue;
            } else if (is_array( $exclude_keys ) && in_array( $k, $exclude_keys )) {
                continue;
            }

            $mixed->$k = htmlspecialchars( $v, $quote_style, 'UTF-8' );
        }
    }
}

function saveAsPrice($val){
    $val = str_replace(",",".",$val);
return floatval($val);
}

function getPriceDiscount($price, $discount){
    return $price - ($price*$discount/100);
}

function getSeoSegment($str){
    return str_replace(":", "-", $str);
}

function setPrevSelLang($lang){
    $session =& JFactory::getSession();
    $jshopConfig = &JSFactory::getConfig();
    $session->set("history_select_lang", $jshopConfig->cur_lang);
}
function getPrevSelLang(){
    $session =& JFactory::getSession();
    return $session->get("history_select_lang");
}

function redirectToThisPageThisLang(){
    $GLOBALS["joomshoppinglangredirect"] = 0;
    if ($_GET['controller'] == "category"){
        header("HTTP/1.1 301 Moved Permanently");
        header("location: ".JRoute::_("index.php?option=com_jshopping&controller=category&task=view&category_id=".$_GET['category_id']."&Itemid=".$_GET['Itemid']));
        die();
    }
    
    if ($_GET['controller'] == "manufacturer"){
        header("HTTP/1.1 301 Moved Permanently");
        header("location: ".JRoute::_("index.php?option=com_jshopping&controller=manufacturer&task=view&manufacturer_id=".$_GET['manufacturer_id']."&Itemid=".$_GET['Itemid']));
        die();
    }
    
    if ($_GET['controller'] == "product"){
        header("HTTP/1.1 301 Moved Permanently");
        header("location: ".JRoute::_("index.php?option=com_jshopping&controller=product&task=view&category_id=".$_GET['category_id']."&product_id=".$_GET['product_id']."&Itemid=".$_GET['Itemid']));
        die();
    }
}

function setFilterAlias($alias){
    $alias = str_replace(" ","-",$alias);
    $alias = (string) preg_replace('/[\x00-\x1F\x7F<>"\'$#%&\?\/\.\)\(\{\}\+\=\[\]\\\,:;]/', '', $alias);
    $alias = JString::strtolower($alias);
return $alias;
}

function showMarkStar($rating){
    $jshopConfig = &JSFactory::getConfig();
    $count = floor($jshopConfig->max_mark / $jshopConfig->rating_starparts);
    $width = $count * 16;
    $rating = round($rating);
    $width_active = intval($rating * 16 / $jshopConfig->rating_starparts);    
    $html = "<div class='stars_no_active' style='width:".$width."px'>";
    $html .= "<div class='stars_active' style='width:".$width_active."px'>";
    $html .= "</div>";
    $html .= "</div>";
return $html;
}

function getNameImageLabel($id, $type = 1){
static $listLabels;
    if (!is_array($listLabels)){
        $productLabel = &JTable::getInstance('productLabel', 'jshop');
        $listLabels = $productLabel->getListLabels();
    }
    $obj = $listLabels[$id];
    if ($type==1)
        return $obj->image;
    else
        return $obj->name;

}

function listProductUpdateData($products, $setUrl = 0){
    $userShop = &JSFactory::getUserShop();
    $jshopConfig = &JSFactory::getConfig();
    foreach ($products as $key=>$value){
        $products[$key]->product_price = $products[$key]->product_price * $jshopConfig->currency_value;
        $products[$key]->product_old_price = $products[$key]->product_old_price * $jshopConfig->currency_value;
        
        $products[$key]->product_price = getPriceDiscount($products[$key]->product_price, $userShop->percent_discount);
        $products[$key]->product_old_price = getPriceDiscount($products[$key]->product_old_price, $userShop->percent_discount);
        
        $products[$key]->basic_price_info = getProductBasicPriceInfo($value, $products[$key]->product_price);
    }
    if ($setUrl){
        addLinkToProducts($products, 0, 1);
    }    
    return $products;
}

function getProductBasicPriceInfo($obj, $price){
    $jshopConfig = &JSFactory::getConfig();
    $price_show = ($obj->weight_volume_units!=0 && $obj->weight_volume_units!=1);
    
    if (!$jshopConfig->admin_show_product_basic_price || $price_show==0){
        return array("price_show"=>0);
    }
        
    $units = &JSFactory::getAllUnits();        
    $unit = $units[$obj->basic_price_unit_id];
    $basic_price = $price / $obj->weight_volume_units * $unit->qty;
          
    return array("price_show"=>$price_show, "basic_price"=>$basic_price, "name"=>$unit->name, "unit_qty"=>$unit->qty);
}

function changeProductTextUsePlugin(&$product){
    $mainframe =& JFactory::getApplication();
    $dispatcher =& JDispatcher::getInstance();
    JPluginHelper::importPlugin('content');
    $obj = new stdClass();
    $params = &$mainframe->getParams('com_content');
    $obj->id = $product->product_id;
    $obj->text = $product->description;        
    $obj->title = $product->name;
    $results = $dispatcher->trigger('onPrepareContent', array (&$obj, &$params, 0));
    $product->description = $obj->text;
    return 1;
}

?>